<template>
  <div class="MindmapsTab _tabcontent">
    <tab-simple
      v-model="items"
      :is-tab-active="isTabActive"
      :item-title="'L: open with xmind'"
      @leftClick="leftClick"
      @rightClick="rightClick"
      @middleClick="middleClick"
      @create="createItem"
      @onTabActive="onTabActive"
      tab-name="mindmaps"
      single-item="mindmap">
      <template slot="controls" slot-scope="prop">
        <i @click="renameItem(prop.item)" class="fa fa-pencil-square-o" aria-hidden="true" title="rename mindmap"></i>
        <i @click="deleteItem(prop.item)" class="fa fa-trash" aria-hidden="true" title="delete mindmap"></i>
      </template>
    </tab-simple>
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  data() {
    return {
      items: [],
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
  },
  mounted() {
    if (this.isTabActive) {
      this.onTabActive()
    }
  },
  methods: {
    async onTabActive() {
      if (!this.items.length) {
        const { data } = await this.$axios.get(`/mindmaps/get`)
        this.items = data
      }
    },
    leftClick(item) {
      const mindmapsPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'mindmaps')
      open(path.join(mindmapsPath, `${item.name}.xmind`))
      win.close()
    },
    rightClick(item) {

    },
    middleClick(item) {

    },
    createItem() {
      this.$prompt(`Create mindmap`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.]+$/,
        inputErrorMessage: 'Invalid mindmap name'
      }).then(async (data) => {
        const mindmapName = data.value
        const mindmapsPath = path.join(os.homedir(), 'one-punch-web', 'sources', 'mindmaps')
        const Workbook = xmind.Workbook
        const workbook = new Workbook({
          firstSheetId: 'sheet-1',
          firstSheetName: mindmapName,
          rootTopicId: 'topic-1',
          rootTopicName: mindmapName
        })
        await workbook.save(path.join(mindmapsPath, `${mindmapName}.xmind`))
        this.leftClick(mindmapName)
      }).catch(e => {
        console.log(e)
      })
    },
    renameItem(item) {
      this.$prompt(`Rename "${item.name}" mindmap to:`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.]+$/,
        inputErrorMessage: 'Invalid mindmap name'
      }).then(async (data) => {
        const newMindmapName = data.value
        if (newMindmapName && newMindmapName !== item.name) {
          await this.$axios.post(`/mindmaps/rename/${item.name}`, {
            newName: data.value
          })
          const index = _.findIndex(this.items, { name: item.name })
          this.items.splice(index, 1, { name: newMindmapName })
        }
      }).catch(e => {})
    },
    deleteItem(item) {
      this.$confirm(`Delete mindmap ${item.name}. Continue?`, 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        await this.$axios.post(`/mindmaps/delete/${item.name}`)
        const index = _.findIndex(this.items, { name: item.name })
        this.items.splice(index, 1)
      })
    },
  }
}
</script>

<style lang="less" scoped>
@import "./MindmapsTab.less";
</style>